package Client;

import Shared.Board;
import Shared.Constants;

import java.net.Socket;
import java.util.Properties;
import java.io.*;

import Shared.Messages.ServerInitial;

/**
 */
public abstract class  Client extends Thread{
    /**
     * Contains board information.
     */
    public Board board ;
    /**
     * IP address or host name of server.
     */
    String server ;
    /**
     * Listeninig port of server.
     */
    private int port;
    /**
     * Initial parameters sent from server to client.
     */
    ServerInitial init;

    public Client(int n , int color) {
        init  = new  ServerInitial(100 , n , color);
        init.color = color ;
        board = new Board(n) ;
    }

    public Client(String fileName) throws IOException {
        Properties prop = new Properties();
        FileInputStream fis = new FileInputStream(fileName);
        prop.load(fis) ;
        server = prop.getProperty("Server" , "localhost") ;
        port = Integer.parseInt(prop.getProperty("Port") ) ;
        fis.close();
    }

    /**
     * The core functionality of a client. this method is
     * called whenever its turn of the player.
     * @return  Line number to be marked in this turn.
     */
    public abstract int doPlay() ;

    public void run() {
        try {
            Socket socket = new Socket(server , port) ;
            BufferedReader reader = new BufferedReader(
                    new InputStreamReader(socket.getInputStream()));
            Writer writer = new OutputStreamWriter(socket.getOutputStream()) ;

            String line = reader.readLine() ;
            //System.out.println("MSG :" + line);
            init = ServerInitial.parseString(line);
            if (init.color == Constants.RED)
                System.out.println("I'm Red palyer");
            else
                System.out.println("I'm Blue player") ;
            board = new Board(init.boardSize);

            do {
                line = reader.readLine() ;
                //System.out.println("MSG :" + line);
                board.parseString(line);
                //System.out.println("Board is" + board);
                writer.write(doPlay() + "\n");
                writer.flush();


            } while (true) ;


        } catch (IOException e) {
            e.printStackTrace();  //To change body of catch statement use Options | File Templates.
        }
    }
}
