package Client.Util;

import org.apache.log4j.Logger;

import java.util.HashSet;
import java.util.Set;
import java.util.Iterator;

/**
 * Created by IntelliJ IDEA.
 * User: sehsanm
 * Date: Jan 26, 2005
 * Time: 9:59:36 PM
 * To change this template use Options | File Templates.
 */
public class Cell {

    static Logger logger = Logger.getLogger("Util") ;

    /**
     * Board size (points count)
     */
    int n ;
    int row , column ;
    int degree ;
    int unMarked ;
    boolean hasGoodNeigh ;
    private HashSet unMarkedLines = new HashSet();
    BoardGraph context ;
    Set neighbors = new HashSet() ;
    int id ;
    boolean flag ;
    int tempData ;
    boolean readyToOccupy ;
    boolean occupyIfDad;
    Cell(BoardGraph cntx ,int n, int row, int column) {
        context = cntx ;
        this.n = n;
        this.row = row;
        this.column = column;
        reset();
    }

   void reset() {
       neighbors.clear();
       hasGoodNeigh = true ;
        degree = 4 ;
        if (this.row == 0 || this.row == (n - 2))
            degree-- ;
        if (this.column == 0 || this.column == (n -2))
            degree-- ;
        unMarked = 4 ;
    }

    int upLine() {
        return n * (n -1) + (n - 1) * row + column + 1 ;
    }

    int downLine() {
        return n * (n -1) + (n - 1) * (row + 1)  + column + 1 ;
    }

    int leftLine() {
        return (n - 1) * column + row + 1 ;
    }

    int rightLine() {
        return (n - 1) * (column + 1) + row + 1 ;
    }

    boolean isAdjacent(Cell c) {
        boolean ret = false ;
        ret |= (Math.abs(row - c.row) == 1) && (c.column == column) ;
        ret |= (Math.abs(column - c.column) == 1) && (c.row == row) ;
        return ret ;
    }

    public int getIntersectedLine(Cell c) {
        if (!isAdjacent(c))
            return -1 ;
        if (c.row == row) {
            if (c.column == column + 1) {
                return rightLine() ;
            }
            else
                return leftLine() ;
        } else {
            if (c.row == row + 1)
                return downLine() ;
            else
                return upLine() ;

        }
    }

    public Set getUnmarkedLines() {
        if (unMarkedLines.size()  == unMarked)
            return unMarkedLines ;
        unMarkedLines.clear();
        Integer i ;
        i = new Integer(upLine()) ;
        if (!context.markedLines.contains(i))
            unMarkedLines.add(i)  ;
        i = new Integer(leftLine()) ;
        if (!context.markedLines.contains(i))
            unMarkedLines.add(i)  ;
        i = new Integer(downLine()) ;
        if (!context.markedLines.contains(i))
            unMarkedLines.add(i)  ;
        i = new Integer(rightLine()) ;
        if (!context.markedLines.contains(i))
            unMarkedLines.add(i)  ;
        if (unMarkedLines.size() != unMarked) {
            throw new NullPointerException("Bad Situation");
        }
        return unMarkedLines  ;

    }


    public String toString() {
        return "[" + row + ", " + column + "]" ;
    }

    public boolean equals(Object obj) {
        Cell c = (Cell) obj ;
        return (c.row == row) && (c.column == column) ;
    }

    public int hashCode() {
        return n * row + column ;
    }

}
