package Client.Util;

import org.apache.log4j.Logger;

import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: sehsanm
 * Date: Jan 28, 2005
 * Time: 5:26:03 PM
 * To change this template use Options | File Templates.
 */
public class Graph {

    public static final int GENERALTYPE = 4;
    public static final int OPTIONTYPE = 3;
    public static final int FIXEDTYPE = 1;
    public static final int ALLSAMETYPE = 2;
    static int temp = 0;
    int[] degCount = new int[4];
    public int totalRTO = 0 ;
    Set magicUnmarkeds = new HashSet();
    static Logger logger = Logger.getLogger("Util");

    ArrayList magicLine;
    HashSet unMarkedLines;
    HashSet cells;
    int type;
    int bestScore = -1;
    private boolean isTree = true;
    int turnScore = -1;
    Cell root;
    int id;

    public int getBestScore() {
        return bestScore;
    }

    public int getTurnScore() {
        return turnScore;
    }

    public Graph(BoardGraph context, Cell root, int id) {
        //logger.info("Constructing ");
        this.id = id;
        this.root = root;
        unMarkedLines = new HashSet();
        cells = new HashSet();
        int x = parse(root , null);
        if  (root.unMarked == 1)
            totalRTO = x ;
        findType();
        //printGraph();
    }

    private void printGraph() {
        String ret = "Magic line is: ";
        for (Iterator iterator = magicLine.iterator(); iterator.hasNext();) {
            ret += iterator.next() + "  ";
        }
        logger.info(ret);
        ret = "Unmarked lines :";
        for (Iterator iterator = unMarkedLines.iterator(); iterator.hasNext();) {
            ret += iterator.next() + "  ";
        }
        logger.info(ret);
        logger.info(this.toString());
    }

    int getSize() {
        return cells.size();
    }

    public int getType() {
        return type;
    }

    private void findType() {
        Cell current = root;
        magicLine = new ArrayList();
        type = GENERALTYPE;
        if (root.unMarked == 1) {

            do {
                ///System.out.println("Current " + current + " " + current.unMarked);
                if (current.unMarked > 2)
                    break;
                magicLine.add(current);
                if (current.unMarked == 1 && root != current)
                    break;
                //Cell.unmarked should be  2
                Cell next = null;
                Iterator it = current.neighbors.iterator();
                if (!it.hasNext())  //Border cell
                    break;
                Object obj = it.next();
                if (!magicLine.contains(obj)) {
                    next = (Cell) obj;
                } else if (it.hasNext()) { //TODO inja kheili code kasifie dorostesh kon
                    next = (Cell) it.next();
                } else
                    break;
                current = next;

            } while (true); //Thos breaks should work


            if (current.unMarked == 2) {
                type = OPTIONTYPE;
                bestScore = magicLine.size();
                turnScore = magicLine.size() - 2;
            } else if (current.unMarked == 1 && magicLine.size() <= 3) {
                bestScore = magicLine.size();
                type = FIXEDTYPE;
            } else if (current.unMarked == 1) {
                type = OPTIONTYPE;
                bestScore = magicLine.size();
                turnScore = magicLine.size() - 4;
            } else if (magicLine.size() >= 2){
                bestScore = magicLine.size() ;
                turnScore = magicLine.size() - 2 ;
            }


/*
            else if (isTree && degCount[1] > 0) {
                type = OPTIONTYPE;
                bestScore = magicLine.size();
                turnScore = magicLine.size() - 4;
            } else if (isTree) {
                bestScore = magicLine.size();
                type = FIXEDTYPE;
            }
*/

        }
        //Previous evaluations were unsuccessful
        if (type == GENERALTYPE && degCount[1] == cells.size()) {
            type = ALLSAMETYPE;
        }

        for (Iterator iterator = magicLine.iterator(); iterator.hasNext();) {
            Cell cell = (Cell) iterator.next();
            magicUnmarkeds.addAll(cell.getUnmarkedLines()) ;
        }
        //logger.info("Type is " + type);


    }

    private int parse(Cell root , Cell dad) {

        root.readyToOccupy = false  ;
        root.occupyIfDad = false ;
        if (root.unMarked == 1)
            root.readyToOccupy = true ;

        degCount[root.unMarked - 1]++;
        int ch = 0;
        root.id = id;
        Set s = root.getUnmarkedLines();
        unMarkedLines.addAll(s);
        int neighRTO = 0 ;
        int offset = 2 ;

        if (dad != null && dad.readyToOccupy == true)
        {
            neighRTO++ ;
            offset = 1 ;
        }
        if (root.unMarked <= neighRTO+1 )
            root.readyToOccupy = true ;

        if (root.unMarked <= neighRTO+offset )
            root.occupyIfDad = true ;


        //logger.debug("unMarked lines : " + root + " " + s );
        cells.add(root);
        int fail = 0;
        int all = 0 ;
        for (Iterator iterator = root.neighbors.iterator(); iterator.hasNext();) {
            Cell cell = (Cell) iterator.next();
            if (cells.size() == 2 && cell.row == 1 && cell.column == 2) {
                int x = 0;
            }
            if (cells.contains(cell)) {
                fail++;
                continue;
            }
            ch = parse(cell , root);
            if  (cell.readyToOccupy)
                neighRTO++ ;
            if (root.unMarked <= neighRTO+1 )
                root.readyToOccupy = true ;
            if (root.unMarked <= neighRTO+offset )
                root.occupyIfDad = true ;
            if (cell.occupyIfDad)
                all += ch ;

        }

        if (root.unMarked <= neighRTO+1 )
            root.readyToOccupy = true ;
        if (root.readyToOccupy)
            totalRTO++ ;
        if (fail > 1)
            isTree = false;
        if (root.occupyIfDad)
            return all + 1;
        else
            return 0 ;
    }

    public int getSafeLineNo() {
        boolean choose = false;
        if (type == FIXEDTYPE) {
            choose = true;
        } else if (type == OPTIONTYPE || type == GENERALTYPE) {
            if (magicLine.size() > 4) {
                choose = true;
            } else if (magicLine.size() <= 4) {
                Cell last = (Cell) magicLine.get(magicLine.size() - 1);
                if (last.unMarked == 2 && magicLine.size() > 2) {
                    choose = true;
                }
            }
        }
        if (choose) {
            Cell c = (Cell) magicLine.get(0);
            if (c.unMarked != 1)
                throw new NullPointerException("Degree of First cell of MagicLine in not 1");
            Integer i = (Integer) c.getUnmarkedLines().iterator().next();
            return i.intValue();

        }
        return -1;
    }

    public int getTrunLine() {
        if (type == OPTIONTYPE  || type == GENERALTYPE ) {

            Cell last = (Cell) magicLine.get(magicLine.size() - 1);
            if (last.unMarked == 2 && magicLine.size() == 2) {
                Cell first = (Cell) magicLine.get(0) ;
                Set unmarks = last.getUnmarkedLines() ;
                unmarks.removeAll(first.getUnmarkedLines()) ;
                if (unmarks.size() != 1)
                    throw new NullPointerException("Number of unmarked lines should be 1") ;
                Integer i = (Integer) unmarks.iterator().next() ;
                return i.intValue() ;


            } if (last.unMarked == 1 && magicLine.size() == 4) {
                Cell second = (Cell) magicLine.get(1) ;
                Cell third = (Cell) magicLine.get(2) ;
                int x = second.getIntersectedLine(third) ;
                return x ;
            }
        }
        return -1;
    }

    public int getUnSafeLine() {
        if  (magicLine.size() > 0 ) {
            Cell c = (Cell) magicLine.get(0);
            if (c.unMarked != 1)
                throw new NullPointerException("Degree of First cell of MagicLine in not 1");
            Integer i = (Integer) c.getUnmarkedLines().iterator().next();
            return i.intValue();

        }

        return -1 ;
    }


    public boolean hasOption() {
        if (magicLine.size() >= 2)
            return true ;
        return false ;
    }

    public String toString() {
        String ret ="";
        ret += "Type= " + type ;
        ret += "{ ";
        for (Iterator iterator = cells.iterator(); iterator.hasNext();) {
            Cell cell = (Cell) iterator.next();
            ret += cell + " , ";


        }
        ret += " }";
        return ret;
    }
}
