
import Client.ABGraph;

import java.io.*;

import Shared.Board;
import Shared.Constants;

/**
 * User: Naeem
 * Date: Feb 1, 2005
 * Time: 9:18:31 PM
 */
public class OfflineServer {
    BufferedReader reader ;
    Client.Client c ;
    boolean red ;
    int n ;
    public OfflineServer(String fileName ,boolean red ) throws IOException {
        this.red = red ;
        try {
            reader = new BufferedReader(new InputStreamReader(new FileInputStream(fileName)));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        n = Integer.parseInt(reader.readLine()) ;
        if (red)
            c = new ABGraph(n ,Constants.RED) ;
        else
            c = new ABGraph(n ,Constants.BLUE) ;

    }
    public void run() throws IOException {
        boolean redT = true ;
        String line = reader.readLine() ;
        int lb = 0 ;
        int lr = 0 ;
        Board b = new Board(n) ;

        while (!b.isFinished()) {
            c.board.parseString(line);
            if (!redT ^ red)
                c.doPlay() ;
            line = reader.readLine() ;
            b.parseString(line);
            int nr = b.count(Constants.RED) ;
            int nb = b.count(Constants.BLUE) ;
            if (nr > lr)
                redT = true ;
            else if (nb > lb)
                redT = false ;
            else
                redT = !redT ;
            lr = nr ;
            lb = nb ;
        }

    }
    public static void main(String[] args) {
        try {
            OfflineServer s = new OfflineServer("replay.txt" , true);
            s.run();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
