package Viewer;

import Shared.Board;

import javax.swing.*;
import java.io.*;
import java.io.OutputStreamWriter ;
import java.net.Socket;
import java.util.Properties;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;

/**
 * Created by IntelliJ IDEA.
 * User: sehsanm
 * Date: Dec 15, 2004
 * Time: 11:15:19 PM
 * To change this template use Options | File Templates.
 */
public class Viewer {
    BufferedReader reader;
    OutputStreamWriter replayWriter ;
    boolean online ;
    int port;
    String serverIP;
    int n;
    Board board;

    public Viewer(String fileName , boolean onlineMode) throws IOException {
        online = onlineMode  ;
        Properties prop = new Properties();
        prop.load(new FileInputStream(fileName));
        port = Integer.parseInt(prop.getProperty("Port"));
        serverIP = prop.getProperty("Server", "localhost");
        String rFile  = prop.getProperty("SaveFile") ;
        if (onlineMode) {
            Socket s = new Socket(serverIP, port);
            reader = new BufferedReader(new InputStreamReader(s.getInputStream()));
            if (rFile != null)
                replayWriter =new OutputStreamWriter (
                        ( new FileOutputStream(rFile)));
                   }
        else
            reader = new BufferedReader(new InputStreamReader(new FileInputStream(rFile))) ;
    }

    public void show() {
        try {
            System.out.println("Showing");
            String line = reader.readLine() ;
            if (replayWriter != null && online)
                replayWriter.write(line + "\r\n");
            n = Integer.parseInt(line);
            System.out.println("Got n:" + n );
            board = new Board(n);
            JFrame frame = new JFrame("Noghteh Khat Viewer.Viewer");
            JPanel panel = new BoardViewer(board);
            frame.getContentPane().add(panel);
            frame.pack();
            frame.setVisible(true);

            frame.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    System.exit(0);
                }
            });
            while (true) {
                line = reader.readLine();
                if (!online)
                {
                    System.out.println("Press a key to continue");
                    System.in.read() ;
                }
                if (replayWriter != null && online)  {
                    replayWriter.write(line + "\r\n");
                    replayWriter.flush();
                }

                board.parseString(line);
                panel.repaint();
            }
        } catch (NumberFormatException e) {
            e.printStackTrace();  //To change body of catch statement use Options | File Templates.
        } catch (IOException e) {
            e.printStackTrace();  //To change body of catch statement use Options | File Templates.
        }
    }

}
